package com.mgh.pmdm.parques.viewmodel

import android.content.Context
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.mgh.pmdm.parques.R
import com.mgh.pmdm.parques.db.Park
import com.mgh.pmdm.parques.view.ui.parkViewHolder

class AdaptadorParques(
    val viewModel: MainViewModel,                           // Referencia al ViewModel
    val eventListenerClick: (Park, View) -> Unit,           // Callbacks
    val eventListenerLongClick: (Park, View) -> Boolean
) : RecyclerView.Adapter<RecyclerView.ViewHolder>() {

    // Método invocado por el RecyclerView cuando necesita un nuevo ViewHolder
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): RecyclerView.ViewHolder {
        val inflater = LayoutInflater.from(parent.context)
        val vista = inflater.inflate(R.layout.parque_card, parent, false);
        return parkViewHolder(vista)

    }

    // Método invocado por el RecyclerView para enlazar un ViewHolder con un parque
    override fun onBindViewHolder(holder: RecyclerView.ViewHolder, position: Int) {
        (holder as parkViewHolder).bind(
            (viewModel.parkList.value?.get(position)) as Park,
            eventListenerClick,
            eventListenerLongClick
        );

    }


    // Devuelve el número de elementos del Dataset
    override fun getItemCount(): Int {
        return viewModel.parkList.value?.size ?: -1

    }
}